/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the scroll bar widget.
***************************************************************/

/*scroll_bar.c*/

#include <Xm/Xm.h>
#include <Xm/ScrollBar.h>

XtAppContext context;

Widget toplevel, scroll;

void scrollCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmAnyCallbackStruct *call_data;
/* called every time the scroll bar changes. */
{
    int value;
    Arg al[10];
    int ac;

    /* get the value of the scroll bar. */
    ac=0;
    XtSetArg(al[ac], XmNvalue, &value); ac++;
    XtGetValues(w,al,ac);

    printf("value = %d\n",value);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the scroll bar. */
    ac=0;
    XtSetArg(al[ac],XmNminimum,0); ac++;
    XtSetArg(al[ac],XmNmaximum,1000); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    XtSetArg(al[ac],XmNwidth,300); ac++;
    scroll=XmCreateScrollBar(toplevel,"scroll",al,ac);
    XtManageChild(scroll);
    XtAddCallback (scroll, XmNvalueChangedCallback, scrollCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
